﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Schedules;
using System.Collections.ObjectModel;
using Infragistics.Controls.Schedules.Primitives;

namespace OutlookCalendarViewHeaderClick
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Resource> resources = new ObservableCollection<Resource>();
        ObservableCollection<ResourceCalendar> calendars = new ObservableCollection<ResourceCalendar>();
        ObservableCollection<Appointment> appointments = new ObservableCollection<Appointment>();
        ObservableCollection<Task> tasks = new ObservableCollection<Task>();

        
        public MainWindow()
        {
            InitializeComponent();
        }

        private void DayArea_Loaded(object sender, RoutedEventArgs e)
        {
            //var activityArea = Infragistics.Windows.Utilities.GetAncestorFromType(((sender as MultiDayActivityArea) as DependencyObject), typeof(DayViewDayHeaderArea), true) as DayViewDayHeaderArea;
            //if (null != activityArea)
            //{
            //    var presenters = FindVisualChildren<AppointmentPresenter>(activityArea);
              
            //  if(presenters != null)
            //    {
            //        foreach (var presenter in presenters)
            //        {
            //            var path = FindVisualChildren<Path>(presenter).Where(p => p.Name == "BorderPath").FirstOrDefault();
            //            path.Fill = Brushes.Green;
            //        }
            //    }
            //}
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            resources.Add(new Resource
            {
                Id = "own1",
                Name = "Amanda"
            });


            calendars.Add(new ResourceCalendar
            {
                Id = "cal1",
                OwningResourceId = "own1"
            });

            for (int i = 0; i < 1; i++)
            {
                Appointment app = new Appointment
                {
                    Id = "t" + i,
                    OwningCalendarId = "cal1",
                    OwningResourceId = "own1",
                    Subject = "Appointment " + i,
                    Description = "My  appointment" + i,
                    Start = DateTime.Today.ToUniversalTime(),
                    End = DateTime.Today.AddHours(24).ToUniversalTime()
                };

                appointments.Add(app);
            }
  
            //===================== Setting the time zone to the local time zone ==============================//
            dataConnector.TimeZoneInfoProviderResolved.LocalTimeZoneId = TimeZone.CurrentTimeZone.StandardName;
            // ================================================================================================//
            dataConnector.ResourceItemsSource = resources;
            dataConnector.ResourceCalendarItemsSource = calendars;
            dataConnector.AppointmentItemsSource = appointments;
            dataConnector.TaskItemsSource = tasks;

        }

        public static IEnumerable<T> FindVisualChildren<T>(DependencyObject depObj) where T : DependencyObject
        {
            if (depObj != null)
            {
                for (int i = 0; i < VisualTreeHelper.GetChildrenCount(depObj); i++)
                {
                    DependencyObject child = VisualTreeHelper.GetChild(depObj, i);
                    if (child != null && child is T)
                    {
                        yield return (T)child;
                    }

                    foreach (T childOfChild in FindVisualChildren<T>(child))
                    {
                        yield return childOfChild;
                    }
                }
            }
        }
    }

}
